from typing import TypedDict, Dict
from datacaster.classes import CastDataClass


class VirtualMachineData(CastDataClass):
    id: str
    name: str
    type: str
    location: str
    tags: Dict[str, str] = {}
    vm_id: str


class VirtualMachine(TypedDict):
    """
    - Contains information about an Azure Virtual Machine instance

    !!! info "VirtualMachine Keys"

        __id__:  Resource ID (including Resource Group)

        __name__:  Resource name

        __type__:  Resource type

        __location__:  Resource location

        __tags__:  Dictionary of tags

        __vm_id__: VM unique ID
    """

    __annotations__ = VirtualMachineData.__dict__["__annotations__"]
